src/config/urls.py
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include
from django.views.generic.base import TemplateView

from accounts.views import send_email
from config import settings

urlpatterns = [
    path("admin/", admin.site.urls),
    path("__debug__/", include("debug_toolbar.urls")),
    path("accounts/", include("accounts.urls")),
    path("accounts/", include("django.contrib.auth.urls")),
    path("", TemplateView.as_view(template_name="index.html"), name="index"),
    path("", include("base_app.urls")),
    path("", include("students.urls")),
    path("", include("teachers.urls")),
    path("", include("groups.urls")),
    path("send-test-email/", send_email, name="send_email"),
    path("oauth/", include("social_django.urls", namespace="social")),
    path("accounts/", include("django.contrib.auth.urls")),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

# handler404 = "students.views.custom_404"
# handler404 = "Custom404View.as_view()"

src/groups/urls.py
from django.urls import path

from .views import IndexView, AllGroups, UpdateGroupView, DeleteGroup, CreateGroupView

app_name = "groups"

urlpatterns = [
    path("", IndexView.as_view(), name="index"),
    path("groups/", AllGroups.as_view(), name="groups"),
    path("groups/create/", CreateGroupView.as_view(), name="create_group"),
    path("groups/update/<int:pk>/", UpdateGroupView.as_view(), name="update_group"),
    path("groups/delete/<int:pk>/", DeleteGroup.as_view(), name="delete_group"),
]

src/teachers/urls.py
from django.urls import path

from teachers.views import (
    AllTeachers,
    CreateTeacherView,
    UpdateTeacherView,
    DeleteTeacher,
    IndexView,
)
from . import views

app_name = "teachers"

urlpatterns = [
    path("", IndexView.as_view(), name="index"),
    path("teachers/", AllTeachers.as_view(), name="teachers"),
    path("teachers/create/", CreateTeacherView.as_view(), name="create_teacher"),
    path(
        "teachers/update/<uuid:uuid>/",
        UpdateTeacherView.as_view(),
        name="update_teacher",
    ),
    path(
        "teachers/delete/<uuid:uuid>/", DeleteTeacher.as_view(), name="delete_teacher"
    ),
    # path("teachers/group/", TeacherListView.as_view(), name="group_teacher"),
    path("teachers/group/", views.group_teacher, name="group_teacher"),
    path("teachers/testing/", views.testing, name="testing"),
]

src/groups/models.py
import random

from django.core.validators import MinLengthValidator
from django.db import models
from faker import Faker

from groups.utils.validators import name_of_curator_validator


# from students.models import Person


class Group(models.Model):
    name_of_curator = models.CharField(
        max_length=120,
        blank=True,
        null=True,
        validators=[MinLengthValidator(1), name_of_curator_validator],
    )
    name_of_teacher = models.CharField(max_length=120)
    group_name = models.CharField(max_length=50)
    quantity_of_students = models.PositiveSmallIntegerField(
        default=20, null=True, blank=True
    )
    start_date = models.DateField(null=True)

    def __str__(self):
        return (
            f"Куратор:{self.name_of_curator} викладач: {self.name_of_teacher}, \n"
            f"дата початку - {self.start_date}, спеціалізація - {self.group_name}"
        )

    @classmethod
    def generate_instances(cls, count):
        fake = Faker()
        for _ in range(count):
            list_of_specialities = ["Python", "Java", "QA"]
            Group.objects.create(
                name_of_curator=fake.name(),
                name_of_teacher=fake.name(),
                group_name=random.choice(list_of_specialities),
                quantity_of_students=random.randint(10, 15),
                start_date=fake.date_this_year(),
            )

src/teachers/models.py
import random
from datetime import datetime
from uuid import uuid4

from django.core.validators import MinLengthValidator
from django.db import models
from faker import Faker

from students.utils.validators import first_name_validator


class Teacher(models.Model):
    first_name = models.CharField(
        max_length=120,
        blank=True,
        null=True,
        validators=[MinLengthValidator(1), first_name_validator],
    )
    last_name = models.CharField(max_length=120, blank=True, null=True)

    email = models.EmailField(max_length=155, null=True)
    start_date = models.DateField(null=True)
    group_name = models.CharField(max_length=50, null=True)
    birth_date = models.DateField(datetime, null=True)
    uuid = models.UUIDField(default=uuid4, editable=False, null=True, db_index=True)

    group = models.ManyToManyField(
        to="groups.Group",
        related_name="all_teachers_in_group",
    )
    avatar = models.ImageField(
        upload_to="static/teachers/avatars",
        default=None,
        blank=True,
        null=True,
        verbose_name="Avatar",
    )

    def __str__(self):
        return f"{self.first_name} {self.last_name}, email: {self.email}, uuid: {self.uuid}, group: {self.group_name}"

    @classmethod
    def generate_instances(cls, count):
        fake = Faker()
        for _ in range(count):
            Teacher.objects.create(
                first_name=fake.first_name(),
                last_name=fake.last_name(),
                email=fake.email(),
                start_date=fake.date_this_year(),
                group_name=random.choice(["Python", "Java", "QA"]),
                birth_date=fake.date_time_between(start_date="-30y", end_date="-18y"),
            )

src/groups/forms.py
from django.core.exceptions import ValidationError
from django.forms import ModelForm

from .models import Group


class GroupForm(ModelForm):
    class Meta:
        model = Group
        fields = (
            "name_of_curator",
            "name_of_teacher",
            "quantity_of_students",
            "group_name",
        )

    @staticmethod
    def normalize_text(text: str):
        return text.strip().capitalize()

    def clean_name_of_curator(self):
        return self.normalize_text(self.cleaned_data["name_of_curator"])

    def clean_name_of_teacher(self):
        return self.normalize_text(self.cleaned_data["name_of_teacher"])

    def clean(self):
        cleaned_data = super().clean()

        name_of_curator = cleaned_data["name_of_curator"]
        name_of_teacher = cleaned_data["name_of_teacher"]

        if name_of_curator == name_of_teacher:
            raise ValidationError("Curator can't be teacher!")
        return cleaned_data

src/teachers/forms.py
from django import forms
from django.core.exceptions import ValidationError
from django.forms import ModelForm

from .models import Teacher


class TeacherForm(ModelForm):
    class Meta:
        model = Teacher
        fields = ("first_name", "last_name", "email", "group_name")

    @staticmethod
    def normalize_text(text: str):
        return text.strip().capitalize()

    def clean_email(self):
        email = self.cleaned_data["email"]

        if "@mail.ru" in email.lower():
            raise ValidationError("Mail.ru is forbidden!")
        return email

    # def clean_experience(self):
    #     experience = self.cleaned_data["experience"]
    #
    #     if experience <= 1:
    #         raise ValidationError("Your experience is not sufficient")
    #     return experience

    def clean_last_name(self):
        return self.normalize_text(self.cleaned_data["last_name"])

    def clean_first_name(self):
        return self.normalize_text(self.cleaned_data["first_name"])

    def clean(self):
        cleaned_data = super().clean()

        first_name = cleaned_data["first_name"]
        last_name = cleaned_data["last_name"]

        if first_name == last_name:
            raise ValidationError("First_name and last_name cant be equal!")
        return cleaned_data


class UploadFileForm(forms.Form):
    avatar = forms.ImageField()
    resume = forms.FileField()

src/groups/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.urls import reverse_lazy
from django.views.generic import (
    TemplateView,
    ListView,
    CreateView,
    UpdateView,
    DeleteView,
)

from .forms import GroupForm
from .models import Group


class IndexView(TemplateView):
    template_name = "index.html"
    extra_context = {"key": "guys", "site_name": "LMS"}

    def get_context_data(self, **kwargs):
        context = super().get_context_data()
        context["my_name"] = "Oleg"
        return context


class AllGroups(LoginRequiredMixin, ListView):
    model = Group
    template_name = "groups/list.html"
    context_object_name = "groups"


class CreateGroupView(LoginRequiredMixin, CreateView):
    template_name = "groups/create.html"
    form_class = GroupForm
    model = Group
    # fields = ("first_name", "last_name", "email", "group_name")
    success_url = reverse_lazy("students:create_student")


class UpdateGroupView(LoginRequiredMixin, UpdateView):
    template_name = "groups/update.html"
    context_object_name = "groups"
    form_class = GroupForm
    pk_url_kwarg = "pk"
    queryset = Group.objects.filter()
    success_url = reverse_lazy("groups: groups")


class DeleteGroup(LoginRequiredMixin, DeleteView):
    template_name = "groups/delete.html"
    context_object_name = "groups"
    form_class = GroupForm
    pk_url_kwarg = "pk"
    queryset = Group.objects.filter()
    success_url = reverse_lazy("groups:groups")

src/teachers/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.http import HttpRequest
from django.shortcuts import render
from django.urls import reverse_lazy
from django.views.generic import (
    ListView,
    CreateView,
    UpdateView,
    DeleteView,
    TemplateView,
)

from groups.models import Group
from .forms import TeacherForm
from .models import Teacher


class IndexView(TemplateView):
    template_name = "index.html"
    extra_context = {"key": "guys", "site_name": "LMS"}

    def get_context_data(self, **kwargs):
        context = super().get_context_data()
        context["my_name"] = "Oleg"
        return context


# def index(request):
#     return render(request, template_name="index.html")


class AllTeachers(LoginRequiredMixin, ListView):
    model = Teacher
    template_name = "teachers/list.html"
    context_object_name = "teachers"


class CreateTeacherView(LoginRequiredMixin, CreateView):
    template_name = "teachers/create.html"
    form_class = TeacherForm
    model = Teacher
    # fields = ("first_name", "last_name", "email", "group_name")
    success_url = reverse_lazy("teachers:create_teacher")


class UpdateTeacherView(LoginRequiredMixin, UpdateView):
    template_name = "teachers/update.html"
    context_object_name = "teachers"
    form_class = TeacherForm
    pk_url_kwarg = "uuid"
    queryset = Teacher.objects.filter()
    success_url = reverse_lazy("teachers:teachers")


class DeleteTeacher(LoginRequiredMixin, DeleteView):
    template_name = "teachers/delete.html"
    context_object_name = "teachers"
    form_class = TeacherForm
    pk_url_kwarg = "uuid"
    queryset = Teacher.objects.filter()
    success_url = reverse_lazy("teachers:teachers")


# class TeacherListView(View):
#     template_name = "teachers/group.html"
#
#     def get(self, request):
#         groups = Group.objects.filter()
#         return render(request, self.template_name, {"groups": groups})


def group_teacher(request):
    return render(
        request,
        template_name="teachers/group.html",
        context={"data": Group.objects.all()[1]},
    )


def testing(request: HttpRequest):
    Teacher.objects.all().delete()
    target_group = Group.objects.filter(group_name__in=["Python"]).first()
    teachers = target_group.all_teachers_in_group.all()
    print(type(teachers))
    return render(request, template_name="testing.html", context={"data": target_group})

src/templates/teachers/create.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <form method='POST' style="width: 25em; margin: auto">
        {% csrf_token %}
        {{ form|crispy }}
        <button type="submit" class="btn btn-success" value="Create">Create teacher</button>
    </form>
{% endblock content %}

src/templates/teachers/delete.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <form method='POST' style="width: 25em; margin: auto">
        {% csrf_token %}
        {{ form|crispy }}
        <button type="submit" class="btn btn-success" value="delete">Delete teacher</button>
    </form>
{% endblock content %}

src/templates/teachers/group.html
{#{% extends "index.html" %}#}
{#{% load crispy_forms_tags %}#}
{##}
{#{% block content %}#}
{#    <div>#}
{#        <p>Name of group: {{ data.group_name }}</p>#}
{#    </div>#}
{##}
{#{% endblock content %}#}

{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    {% for group in groups %}
        <h2>{{ group.group_name }}</h2>
        <ul>
            {% for teacher in group.teachers.all %}
                <li>{{ teacher.last_name }}</li>
            {% endfor %}
        </ul>
    {% endfor %}

{% endblock content %}

src/templates/teachers/list.html
{% extends "index.html" %}

{% block content %}
    {#    {{ teachers }}#}
    <table class="table table-dark table-striped">
        <thead>
        <tr>
            <th scope="col">#</th>
            <th scope="col">First name</th>
            <th scope="col">Last name</th>
            <th scope="col">Email</th>
            <th scope="col">Start date</th>
            <th scope="col">Experience</th>
            <th scope="col">Birth date</th>
            <th scope="col">Update</th>
            <th scope="col">Delete</th>
            <th scope="col">Group</th>
        </tr>
        </thead>
        <tbody>
        {% for teacher in teachers %}
            <tr>
                <th scope="row"></th>
                <td>{{ teacher.first_name }}</td>
                <td>{{ teacher.last_name }}</td>
                <td>{{ teacher.email }}</td>
                <td>{{ teacher.start_date }}</td>
                <td>{{ teacher.birth_date }}</td>
                {% if teacher.birth_date %}
                    <td>{{ teacher.birth_date }}</td>
                {% else %}
                    <td>Unknown age</td>
                {% endif %}
                {#                <td>{{ teacher.group }}</td>#}


                <th><a type="button" class="btn btn-warning" href="{% url 'teachers:update_teacher' teacher.uuid %}"
                >Update</a></th>
                <th><a type="button" class="btn btn-warning" href="{% url 'teachers:delete_teacher' teacher.uuid %}"
                >Delete</a></th>
                <th><a type="button" class="btn btn-warning" href="{% url 'teachers:group_teacher' %}"
                >Group</a></th>

            </tr>
        {% endfor %}

        </tbody>
    </table>
{% endblock content %}

src/templates/teachers/update.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <form method='POST' style="width: 25em; margin: auto">
        {% csrf_token %}
        {{ form|crispy }}
        <button type="submit" class="btn btn-success" value="Update">Update teacher</button>
    </form>
{% endblock content %}